=== debian/changelog ===
likwid (5.1.0+dfsg1-1) unstable; urgency=medium

  [ Christoph Martin ]
  * New upstream version 5.1.0+dfsg1

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 18 Jan 2021 16:58:59 +0100
