=== src/access-daemon/Makefile ===
--- 
+++ 
@@ -4,13 +4,13 @@
 #
 #      Description:  accessDaemon Makefile
 #
-#      Version:   5.1.0
-#      Released:  20.11.2020
+#      Version:   5.2.1
+#      Released:  03.12.2021
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #      Project:  likwid
 #
-#      Copyright (C) 2020 RRZE, University Erlangen-Nuremberg
+#      Copyright (C) 2021 NHR@FAU, University Erlangen-Nuremberg
 #
 #      This program is free software: you can redistribute it and/or modify it under
 #      the terms of the GNU General Public License as published by the Free Software
