=== debian/changelog ===
likwid (5.2.1+dfsg1-2) unstable; urgency=medium

  * enable usage of system hwloc
  * update to lua 5.3

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 15 Jun 2022 17:54:21 +0200

likwid (5.2.1+dfsg1-1) unstable; urgency=medium

  [ Christoph Martin ]
  * New upstream version 5.2.1+dfsg1

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 14 Jun 2022 10:17:33 +0200

likwid (5.1.0+dfsg1-2) UNRELEASED; urgency=medium

  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on debhelper and dpkg-dev.

 -- Debian Janitor <janitor@jelmer.uk>  Sun, 12 Sep 2021 05:48:18 -0000
