=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: misc
 Priority: optional
 Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), gfortran, liblua5.2-dev
+Build-Depends: debhelper, gfortran, liblua5.3-dev, libhwloc-dev
 Homepage: https://github.com/rrze-likwid/likwid
 Vcs-Git: https://salsa.debian.org/debian/likwid.git
 Vcs-Browser: https://salsa.debian.org/debian/likwid
@@ -11,7 +11,7 @@
 Package: likwid
 Architecture: amd64 i386 x32
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, lua5.2
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, lua5.3
 Suggests: feedgnuplot
 Description: toolsuite for performance oriented programmers
  Likwid is a simple to install and use toolsuite of command line applications
