## likwid 5.2.2%2Bdfsg1

=== ext/GOTCHA/include/CMakeLists.txt ===
install(DIRECTORY gotcha DESTINATION include FILES_MATCHING PATTERN *.h)
