=== debian/changelog ===
likwid (5.2.2+dfsg1-2) unstable; urgency=medium

  * fix clean target (closes: Bug#1046064)
  * wrap-and-sort debian/* files

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 04 Sep 2023 14:08:52 +0200

likwid (5.2.2+dfsg1-1) unstable; urgency=medium

  * remove hwloc and cleanup copyright
  * New upstream version 5.2.2+dfsg1
  * replace DEB_BUILD_GNU_TYPE with DEB_HOST_MULTIARCH (closes: 950368)

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 02 Sep 2022 15:54:43 +0200

likwid (5.2.1+dfsg1-3) unstable; urgency=medium

  * remove obsolete symlink to custom hwloc lib (closes: 1013179)
  * remove hwloc from lintian overrides
  * update watch file src to https
  * add python3 to deps

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 20 Jun 2022 17:31:59 +0200
