## likwid 5.2.2+dfsg1

=== Makefile ===
--- 
+++ 
@@ -4,13 +4,13 @@
 #
 #      Description:  Central Makefile
 #
-#      Version:   5.2.1
-#      Released:  03.12.2021
+#      Version:   5.2.2
+#      Released:  26.07.2022
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #      Project:  likwid
 #
-#      Copyright (C) 2021 NHR@FAU, University Erlangen-Nuremberg
+#      Copyright (C) 2022 NHR@FAU, University Erlangen-Nuremberg
 #
 #      This program is free software: you can redistribute it and/or modify it under
 #      the terms of the GNU General Public License as published by the Free Software
