=== ext/GOTCHA/src/example/CMakeLists.txt ===
add_subdirectory(autotee)
add_subdirectory(minimal)
