=== debian/control ===
--- 
+++ 
@@ -3,29 +3,16 @@
 Section: misc
 Priority: optional
 Standards-Version: 3.9.8
-Build-Depends:
- debhelper,
- dh-python,
- gfortran,
- libhwloc-dev,
- liblua5.3-dev,
- python3,
+Build-Depends: debhelper, dh-python, python3, gfortran, liblua5.3-dev, libhwloc-dev
 Homepage: https://github.com/rrze-likwid/likwid
 Vcs-Git: https://salsa.debian.org/debian/likwid.git
 Vcs-Browser: https://salsa.debian.org/debian/likwid
 
 Package: likwid
 Architecture: amd64 i386 x32
-Pre-Depends:
- ${misc:Pre-Depends},
-Depends:
- lua5.3,
- ${misc:Depends},
- ${perl:Depends},
- ${python3:Depends},
- ${shlibs:Depends},
-Suggests:
- feedgnuplot,
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, ${python3:Depends}, lua5.3
+Suggests: feedgnuplot
 Description: toolsuite for performance oriented programmers
  Likwid is a simple to install and use toolsuite of command line applications
  for performance oriented programmers. It works for Intel and AMD processors
