=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

DCPPFLAGS=$(CPPFLAGS)
DLDFLAGS=$(LDFLAGS)

export DCPPFLAGS DLDFLAGS

%:
	dh $@ --with python3

override_dh_auto_clean:
	mkdir ext/lua
	touch ext/lua/liblikwid-lua.so
	dh_auto_clean

override_dh_auto_build:
	$(MAKE) PREFIX=/usr LIBPREFIX=/usr/lib/$(DEB_HOST_MULTIARCH) INSTALLED_LIBPREFIX=/usr/lib/$(DEB_HOST_MULTIARCH) RPATHS= FORTRAN_INTERFACE=true

override_dh_auto_install:
	$(MAKE) PREFIX=$$(pwd)/debian/likwid/usr INSTALLED_PREFIX=/usr FORTRAN_INTERFACE=true MANPREFIX=$$(pwd)/debian/likwid/usr/share/man LIBPREFIX=$$(pwd)/debian/likwid/usr/lib/$(DEB_HOST_MULTIARCH) install
